//\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\
//
//  This is a listing of a program presented at the C++ at Work Conference.
//
//  The program was presented by William M. Miller of Glockenspiel, Inc.
//  in a seminar entitled Debugging C++. He stated that it was based on
//  an article by Martin J. O'Riordan, presented at the 1988 USENIX C++
//  conference.  (p227-242) in the proceedings.
//
//
//  Listings were provided for the Debugger but none were provided for the
//  example program.  I succeeded in copying freehand the example program
//  during the presentation.  
//
//  There was no mention of copyright on any of the distributed material
//  or within the listing.
//
//  It is with the spirit of learning OOP that I have typed this in and
//  debugged this version of this interesting program.  While it is not
//  anything close to the capability of the Turbo C++ IDE debugger or the
//  Turbo Debugger, I found it a unique and fresh approach to an
//  interesting problem.
//
//  Leland Berkwits  76414,430   January 8, 1991
//
//  Martin J. O'Riordan     martin@puschi.uucp
//  William M. Miller       wmmiller@cup.portal.com
//
//\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/



#include <iostream.h>
#define DEBUGGER_ON
#include "debugger.h"

struct foo: virtual monitored{    // all classes must use monitoreda as base
   foo(const char *nm):monitored(nm), my_name(nm){}
   void display(){ cerr << my_name; }
   const char* my_name;        // storage for name of class
};

void x();
void y();
void z();

int main(){
   trace tt("main");      // used to indicate that main has been entered

   foo *p = new foo("*p");
   x();
   z();
   delete p;
   return 0;
}

void x(){
   trace tt("x");         // used to indicate that x() has been entered
   foo xf("xf");
   y();
}

void y(){
  trace tt("y");          // used to indicate that y() has been entered
  foo yf("yf");
}

void z(){                 // used to indicate that z() has been entered
  trace tt("z");
  foo zf("zf");
}
